Assignee:  % Done: 80%

Category: Issues Estimated time: 0.25 hour

Target version:    

Resolution: Duplicate Affected version:  

Description

The context menu (item "Status>") should only list statuses that the tracker actually uses.

Related issues:

Is duplicate of Redmine - Defect #10181: Issue context menu and bulk edit for... Closed

History

#1 - 2010-09-27 16:46 - Moritz Voss

The fix for this is very small (I think), I will dig it up from my home Redmine install. I am too insecure about Rails development, though, so I am

reluctant to submit this as an actual patch without someone proofreading it.

#2 - 2010-09-27 19:14 - Vitaliy Sotikov

- % Done changed from 0 to 70

#3 - 2010-09-28 00:22 - Moritz Voss

- File context.patch added

- % Done changed from 70 to 80

Very simple patch to reject invalid statuses while the context menu is built.

*** issues.html.erb.html    Mon Sep 27 22:33:00 2010

--- issues.html.erb.html    Tue Sep 28 00:18:43 2010

***************

*** 14,21 ****

--- 14,23 ----

          <a href="#" class="submenu" onclick="return false;"><%= l(:field_status) %></a>

          <ul>

          <% @statuses.each do |s| -%>

+             <% if ((s == @issue.status) || (@allowed_statuses.include?(s))) -%>                    

              <li><%= context_menu_link s.name, {:controller => 'issues', :action => 'bulk_edit', :ids => @iss

ues.collect(&:id), :issue => {:status_id => s}, :back_url => @back}, :method => :post,

                                        :selected => (@issue && s == @issue.status), :disabled => !(@can[:upda

te] && @allowed_statuses.include?(s)) %></li>

+             <% end %>

          <% end -%>

          </ul>

      </li>

#4 - 2010-10-07 06:37 - Jean-Baptiste Barth

Actually statuses that are not allowed are displayed but you cannot select them. Why do you want to completely hide them ? Do you have an explicit

example ?

#5 - 2010-10-07 08:31 - Moritz Voss

It can be confusing for users when you have multiple workflows with numerous custom issue statuses, to see statuses that issues in the current

tracker could never have. Having to skip over statuses when changing them can be tedious - we have a tracker with very "small" issues, that require

being edited in Bulk, and advanced from one status to the next. Having to skip over a large block of unselectable statuses to "done" or "closed", which

needs to be at the bottom of the list to be intuitive, seems to defeat the slick elegance of the context menu.

The unused statuses also take up screen real-estate in this very small menu. The menu gets very large when all the unused statuses are always

listed; it often touches or overlaps the screen or window borders.
Last, but not least, the "Status" field in "Edit Issue" itself does only list valid statuses for each issue - so it's a question of consistency, too. Same

goes for the workflow definition pane in the administration menu - filtering there is even on by default.

#6 - 2010-10-07 08:33 - Moritz Voss

Addendum:

Jean-Baptiste Barth wrote:

Actually statuses that are not allowed are displayed but you cannot select them. Why do you want to completely hide them ? Do you have an

explicit example ?

 Why would you want to show them? Do you have an explicit example ?

(sorry for the retort, but when is it sensible to actually show a status that an issue can never, ever obtain?)

#7 - 2010-10-07 17:58 - Jean-Baptiste Barth

Maybe I misunderstood the problem you pointed out : I though you were talking about statuses the user cannot apply because of a workflow

limitation. If we hide statuses unreachable by the current user, we should also change all other fields display in context menu, it's a more general

problem. Your proposed patch hide some statuses an issue can have, but that the current user cannot set himself.

If you confirm we should only hide statuses that nobody can reach, then OK, I 100% agree and I'll take a look at it.

#8 - 2010-10-08 10:49 - Moritz Voss

Yes, I mean only statuses that the tracker never uses, and grey out statuses the user can't set it to.

In my case, it didn't occur to me that my patch took all the disallowed issues out - the one for 0.9.x didn't so maybe I screwed something up. I will look

into it a little, too.

#9 - 2017-01-11 14:05 - Go MAEDA

- Is duplicate of Defect #10181: Issue context menu and bulk edit form show irrelevant statuses added

#10 - 2017-01-11 14:06 - Go MAEDA

- Category set to Issues

- Status changed from New to Closed

- Resolution set to Duplicate

Fixed by #10181 (Redmine 1.4.0).

Files

context.patch 743 Bytes 2010-09-27 Moritz Voss
